/* addint.c */
void addint(double **uf, double **uc, double **res, int nf);
/* airy.c */
void airy(float x, float *ai, float *bi, float *aip, float *bip);
/* amebsa.c */
void amebsa(float **p, float y[], int ndim, float pb[], float *yb, float ftol, float (*funk)(float []), int *iter, float temptr);
/* amoeba.c */
void amoeba(float **p, float y[], int ndim, float ftol, float (*funk)(float []), int *nfunk);
/* amotry.c */
float amotry(float **p, float y[], float psum[], int ndim, float (*funk)(float []), int ihi, float fac);
/* amotsa.c */
float amotsa(float **p, float y[], float psum[], int ndim, float pb[], float *yb, float (*funk)(float []), int ihi, float *yhi, float fac);
/* anneal.c */
void anneal(float x[], float y[], int iorder[], int ncity);
/* anorm2.c */
double anorm2(double **a, int n);
/* arcmak.c */
void arcmak(unsigned long nfreq[], unsigned long nchh, unsigned long nradd, arithcode *acode);
/* arcode.c */
void arcode(unsigned long *ich, unsigned char **codep, unsigned long *lcode, unsigned long *lcd, int isign, arithcode *acode);
/* arcsum.c */
void arcsum(unsigned long iin[], unsigned long iout[], unsigned long ja, int nwk, unsigned long nrad, unsigned long nc);
/* asolve.c */
void asolve(unsigned long n, double b[], double x[], int itrnsp);
/* atimes.c */
void atimes(unsigned long n, double x[], double r[], int itrnsp);
/* avevar.c */
void avevar(float data[], unsigned long n, float *ave, float *var);
/* balanc.c */
void balanc(float **a, int n);
/* banbks.c */
void banbks(float **a, unsigned long n, int m1, int m2, float **al, unsigned long indx[], float b[]);
/* bandec.c */
void bandec(float **a, unsigned long n, int m1, int m2, float **al, unsigned long indx[], float *d);
/* banmul.c */
void banmul(float **a, unsigned long n, int m1, int m2, float x[], float b[]);
/* bcucof.c */
void bcucof(float y[], float y1[], float y2[], float y12[], float d1, float d2, float **c);
/* bcuint.c */
void bcuint(float y[], float y1[], float y2[], float y12[], float x1l, float x1u, float x2l, float x2u, float x1, float x2, float *ansy, float *ansy1, float *ansy2);
/* beschb.c */
void beschb(double x, double *gam1, double *gam2, double *gampl, double *gammi);
/* bessi.c */
float bessi(int n, float x);
/* bessi0.c */
float bessi0(float x);
/* bessi1.c */
float bessi1(float x);
/* bessik.c */
void bessik(float x, float xnu, float *ri, float *rk, float *rip, float *rkp);
/* bessj.c */
float bessj(int n, float x);
/* bessj0.c */
float bessj0(float x);
/* bessj1.c */
float bessj1(float x);
/* bessjy.c */
void bessjy(float x, float xnu, float *rj, float *ry, float *rjp, float *ryp);
/* bessk.c */
float bessk(int n, float x);
/* bessk0.c */
float bessk0(float x);
/* bessk1.c */
float bessk1(float x);
/* bessy.c */
float bessy(int n, float x);
/* bessy0.c */
float bessy0(float x);
/* bessy1.c */
float bessy1(float x);
/* beta.c */
float beta(float z, float w);
/* betacf.c */
float betacf(float a, float b, float x);
/* betai.c */
float betai(float a, float b, float x);
/* bico.c */
float bico(int n, int k);
/* bksub.c */
void bksub(int ne, int nb, int jf, int k1, int k2, float ***c);
/* bnldev.c */
float bnldev(float pp, int n, long *idum);
/* brent.c */
float brent(float ax, float bx, float cx, float (*f)(float), float tol, float *xmin);
/* broydn.c */
void broydn(float x[], int n, int *check, void (*vecfunc)(int, float [], float []));
/* bsstep.c */
void bsstep(float y[], float dydx[], int nv, float *xx, float htry, float eps, float yscal[], float *hdid, float *hnext, void (*derivs)(float, float [], float []));
/* caldat.c */
void caldat(long julian, int *mm, int *id, int *iyyy);
/* chder.c */
void chder(float a, float b, float c[], float cder[], int n);
/* chebev.c */
float chebev(float a, float b, float c[], int m, float x);
/* chebft.c */
void chebft(float a, float b, float c[], int n, float (*func)(float));
/* chebpc.c */
void chebpc(float c[], float d[], int n);
/* chint.c */
void chint(float a, float b, float c[], float cint[], int n);
/* chixy.c */
float chixy(float bang);
/* choldc.c */
void choldc(float **a, int n, float p[]);
/* cholsl.c */
void cholsl(float **a, int n, float p[], float b[], float x[]);
/* chsone.c */
void chsone(float bins[], float ebins[], int nbins, int knstrn, float *df, float *chsq, float *prob);
/* chstwo.c */
void chstwo(float bins1[], float bins2[], int nbins, int knstrn, float *df, float *chsq, float *prob);
/* cisi.c */
void cisi(float x, float *ci, float *si);
/* cntab1.c */
void cntab1(int **nn, int ni, int nj, float *chisq, float *df, float *prob, float *cramrv, float *ccc);
/* cntab2.c */
void cntab2(int **nn, int ni, int nj, float *h, float *hx, float *hy, float *hygx, float *hxgy, float *uygx, float *uxgy, float *uxy);
/* complex.c */
fcomplex Cadd(fcomplex a, fcomplex b);
fcomplex Csub(fcomplex a, fcomplex b);
fcomplex Cmul(fcomplex a, fcomplex b);
fcomplex Complex(float re, float im);
fcomplex Conjg(fcomplex z);
fcomplex Cdiv(fcomplex a, fcomplex b);
float Cabs(fcomplex z);
fcomplex Csqrt(fcomplex z);
fcomplex RCmul(float x, fcomplex a);
/* convlv.c */
void convlv(float data[], unsigned long n, float respns[], unsigned long m, int isign, float ans[]);
/* copy.c */
void copy(double **aout, double **ain, int n);
/* correl.c */
void correl(float data1[], float data2[], unsigned long n, float ans[]);
/* cosft1.c */
void cosft1(float y[], int n);
/* cosft2.c */
void cosft2(float y[], int n, int isign);
/* covsrt.c */
void covsrt(float **covar, int ma, int ia[], int mfit);
/* crank.c */
void crank(unsigned long n, float w[], float *s);
/* cyclic.c */
void cyclic(float a[], float b[], float c[], float alpha, float beta, float r[], float x[], unsigned long n);
/* daub4.c */
void daub4(float a[], unsigned long n, int isign);
/* dawson.c */
float dawson(float x);
/* dbrent.c */
float dbrent(float ax, float bx, float cx, float (*f)(float), float (*df)(float), float tol, float *xmin);
/* ddpoly.c */
void ddpoly(float c[], int nc, float x, float pd[], int nd);
/* decchk.c */
int decchk(char string[], int n, char *ch);
/* df1dim.c */
float df1dim(float x);
/* dfour1.c */
void dfour1(double data[], unsigned long nn, int isign);
/* dfpmin.c */
void dfpmin(float p[], int n, float gtol, int *iter, float *fret, float (*func)(float []), void (*dfunc)(float [], float []));
/* dfridr.c */
float dfridr(float (*func)(float), float x, float h, float *err);
/* dftcor.c */
void dftcor(float w, float delta, float a, float b, float endpts[], float *corre, float *corim, float *corfac);
/* dftint.c */
void dftint(float (*func)(float), float a, float b, float w, float *cosint, float *sinint);
/* difeq.c */
void difeq(int k, int k1, int k2, int jsf, int is1, int isf, int indexv[], int ne, float **s, float **y);
/* dlinmin.c */
void dlinmin(float p[], float xi[], int n, float *fret, float (*func)(float []), void (*dfunc)(float [], float []));
/* dpythag.c */
double dpythag(double a, double b);
/* drealft.c */
void drealft(double data[], unsigned long n, int isign);
/* dsprsax.c */
void dsprsax(double sa[], unsigned long ija[], double x[], double b[], unsigned long n);
/* dsprstx.c */
void dsprstx(double sa[], unsigned long ija[], double x[], double b[], unsigned long n);
/* dsvbksb.c */
void dsvbksb(double **u, double w[], double **v, int m, int n, double b[], double x[]);
/* dsvdcmp.c */
void dsvdcmp(double **a, int m, int n, double w[], double **v);
/* eclass.c */
void eclass(int nf[], int n, int lista[], int listb[], int m);
/* eclazz.c */
void eclazz(int nf[], int n, int (*equiv)(int, int));
/* ei.c */
float ei(float x);
/* eigsrt.c */
void eigsrt(float d[], float **v, int n);
/* elle.c */
float elle(float phi, float ak);
/* ellf.c */
float ellf(float phi, float ak);
/* ellpi.c */
float ellpi(float phi, float en, float ak);
/* elmhes.c */
void elmhes(float **a, int n);
/* erfcc.c */
float erfcc(float x);
/* erff.c */
#ifdef MACINTOSH
#undef erff
#endif
float erff(float x);
/* erffc.c */
float erffc(float x);
/* eulsum.c */
void eulsum(float *sum, float term, int jterm, float wksp[]);
/* evlmem.c */
float evlmem(float fdt, float d[], int m, float xms);
/* expdev.c */
float expdev(long *idum);
/* expint.c */
float expint(int n, float x);
/* f1dim.c */
float f1dim(float x);
/* factln.c */
float factln(int n);
/* factrl.c */
float factrl(int n);
/* fasper.c */
void fasper(float x[], float y[], unsigned long n, float ofac, float hifac, float wk1[], float wk2[], unsigned long nwk, unsigned long *nout, unsigned long *jmax, float *prob);
/* fdjac.c */
void fdjac(int n, float x[], float fvec[], float **df, void (*vecfunc)(int, float [], float []));
/* fgauss.c */
void fgauss(float x, float a[], float *y, float dyda[], int na);
/* fill0.c */
void fill0(double **u, int n);
/* fit.c */
void fit(float x[], float y[], int ndata, float sig[], int mwt, float *a, float *b, float *siga, float *sigb, float *chi2, float *q);
/* fitexy.c */
void fitexy(float x[], float y[], int ndat, float sigx[], float sigy[], float *a, float *b, float *siga, float *sigb, float *chi2, float *q);
/* fixrts.c */
void fixrts(float d[], int m);
/* fleg.c */
void fleg(float x, float pl[], int nl);
/* flmoon.c */
void flmoon(int n, int nph, long *jd, float *frac);
/* fmin.c */
float nrfmin(float x[]);
/* four1.c */
void four1(float data[], unsigned long nn, int isign);
/* fourew.c */
void fourew(FILE *file[5], int *na, int *nb, int *nc, int *nd);
/* fourfs.c */
void fourfs(FILE *file[5], unsigned long nn[], int ndim, int isign);
/* fourn.c */
void fourn(float data[], unsigned long nn[], int ndim, int isign);
/* fpoly.c */
void fpoly(float x, float p[], int np);
/* fred2.c */
void fred2(int n, float a, float b, float t[], float f[], float w[], float (*g)(float), float (*ak)(float, float));
/* fredin.c */
float fredin(float x, int n, float a, float b, float t[], float f[], float w[], float (*g)(float), float (*ak)(float, float));
/* frenel.c */
void frenel(float x, float *s, float *c);
/* frprmn.c */
void frprmn(float p[], int n, float ftol, int *iter, float *fret, float (*func)(float []), void (*dfunc)(float [], float []));
/* ftest.c */
void ftest(float data1[], unsigned long n1, float data2[], unsigned long n2, float *f, float *prob);
/* gamdev.c */
float gamdev(int ia, long *idum);
/* gammln.c */
float gammln(float xx);
/* gammp.c */
float gammp(float a, float x);
/* gammq.c */
float gammq(float a, float x);
/* gasdev.c */
float gasdev(long *idum);
/* gaucof.c */
void gaucof(int n, float a[], float b[], float amu0, float x[], float w[]);
/* gauher.c */
void gauher(float x[], float w[], int n);
/* gaujac.c */
void gaujac(float x[], float w[], int n, float alf, float bet);
/* gaulag.c */
void gaulag(float x[], float w[], int n, float alf);
/* gauleg.c */
void gauleg(float x1, float x2, float x[], float w[], int n);
/* gaussj.c */
void gaussj(float **a, int n, float **b, int m);
/* gcf.c */
void gcf(float *gammcf, float a, float x, float *gln);
/* golden.c */
float golden(float ax, float bx, float cx, float (*f)(float), float tol, float *xmin);
/* gser.c */
void gser(float *gamser, float a, float x, float *gln);
/* hpsel.c */
void hpsel(unsigned long m, unsigned long n, float arr[], float heap[]);
/* hpsort.c */
void hpsort(unsigned long n, float ra[]);
/* hqr.c */
void hqr(float **a, int n, float wr[], float wi[]);
/* hufapp.c */
void hufapp(unsigned long index[], unsigned long nprob[], unsigned long n, unsigned long i);
/* hufdec.c */
void hufdec(unsigned long *ich, unsigned char *code, unsigned long lcode, unsigned long *nb, huffcode *hcode);
/* hufenc.c */
void hufenc(unsigned long ich, unsigned char **codep, unsigned long *lcode, unsigned long *nb, huffcode *hcode);
/* hufmak.c */
void hufmak(unsigned long nfreq[], unsigned long nchin, unsigned long *ilong, unsigned long *nlong, huffcode *hcode);
/* hunt.c */
void hunt(float xx[], unsigned long n, float x, unsigned long *jlo);
/* hypdrv.c */
void hypdrv(float s, float yy[], float dyyds[]);
/* hypgeo.c */
fcomplex hypgeo(fcomplex a, fcomplex b, fcomplex c, fcomplex z);
/* hypser.c */
void hypser(fcomplex a, fcomplex b, fcomplex c, fcomplex z, fcomplex *series, fcomplex *deriv);
/* icrc.c */
unsigned short icrc(unsigned short crc, unsigned char *bufptr, unsigned long len, short jinit, int jrev);
/* icrc1.c */
unsigned short icrc1(unsigned short crc, unsigned char onech);
/* igray.c */
unsigned long igray(unsigned long n, int is);
/* iindexx.c */
void iindexx(unsigned long n, long arr[], unsigned long indx[]);
/* indexx.c */
void indexx(unsigned long n, float arr[], unsigned long indx[]);
/* interp.c */
void interp(double **uf, double **uc, int nf);
/* irbit1.c */
int irbit1(unsigned long *iseed);
/* irbit2.c */
int irbit2(unsigned long *iseed);
/* jacobi.c */
void jacobi(float **a, int n, float d[], float **v, int *nrot);
/* jacobn.c */
//void jacobn(float x, float y[], float dfdx[], float **dfdy, int n);
//void derivs(float x, float y[], float dydx[]);
/* julday.c */
long julday(int mm, int id, int iyyy);
/* kendl1.c */
void kendl1(float data1[], float data2[], unsigned long n, float *tau, float *z, float *prob);
/* kendl2.c */
void kendl2(float **tab, int i, int j, float *tau, float *z, float *prob);
/* kermom.c */
void kermom(double w[], double y, int m);
/* ks2d1s.c */
void ks2d1s(float x1[], float y1[], unsigned long n1, void (*quadvl)(float, float, float *, float *, float *, float *), float *d1, float *prob);
/* ks2d2s.c */
void ks2d2s(float x1[], float y1[], unsigned long n1, float x2[], float y2[], unsigned long n2, float *d, float *prob);
/* ksone.c */
void ksone(float data[], unsigned long n, float (*func)(float), float *d, float *prob);
/* kstwo.c */
void kstwo(float data1[], unsigned long n1, float data2[], unsigned long n2, float *d, float *prob);
/* laguer.c */
void laguer(fcomplex a[], int m, fcomplex *x, int *its);
/* lfit.c */
void lfit(float x[], float y[], float sig[], int ndat, float a[], int ia[], int ma, float **covar, float *chisq, void (*funcs)(float, float [], int));
/* linbcg.c */
void linbcg(unsigned long n, double b[], double x[], int itol, double tol, int itmax, int *iter, double *err);
/* linmin.c */
void linmin(float p[], float xi[], int n, float *fret, float (*func)(float []));
/* lnsrch.c */
void lnsrch(int n, float xold[], float fold, float g[], float p[], float x[], float *f, float stpmax, int *check, float (*func)(float []));
/* locate.c */
void locate(float xx[], unsigned long n, float x, unsigned long *j);
/* lop.c */
void lop(double **out, double **u, int n);
/* lubksb.c */
void lubksb(float **a, int n, int *indx, float b[]);
/* ludcmp.c */
void ludcmp(float **a, int n, int *indx, float *d);
/* machar.c */
void machar(int *ibeta, int *it, int *irnd, int *ngrd, int *machep, int *negep, int *iexp, int *minexp, int *maxexp, float *eps, float *epsneg, float *xmin, float *xmax);
/* matadd.c */
void matadd(double **a, double **b, double **c, int n);
/* matsub.c */
void matsub(double **a, double **b, double **c, int n);
/* medfit.c */
void medfit(float x[], float y[], int ndata, float *a, float *b, float *abdev);
/* memcof.c */
void memcof(float data[], int n, int m, float *xms, float d[]);
/* metrop.c */
int metrop(float de, float t);
/* mgfas.c */
void mgfas(double **u, int n, int maxcyc);
/* mglin.c */
void mglin(double **u, int n, int ncycle);
/* midexp.c */
float midexp(float (*funk)(float), float aa, float bb, int n);
/* midinf.c */
float midinf(float (*funk)(float), float aa, float bb, int n);
/* midpnt.c */
float midpnt(float (*func)(float), float a, float b, int n);
/* midsql.c */
float midsql(float (*funk)(float), float aa, float bb, int n);
/* midsqu.c */
float midsqu(float (*funk)(float), float aa, float bb, int n);
/* miser.c */
void miser(float (*func)(float []), float regn[], int ndim, unsigned long npts, float dith, float *ave, float *var);
/* mmid.c */
void mmid(float y[], float dydx[], int nvar, float xs, float htot, int nstep, float yout[], void (*derivs)(float, float [], float []));
/* mnbrak.c */
void mnbrak(float *ax, float *bx, float *cx, float *fa, float *fb, float *fc, float (*func)(float));
/* mnewt.c */
void mnewt(int ntrial, float x[], int n, float tolx, float tolf);
/* moment.c */
void moment(float data[], int n, float *ave, float *adev, float *sdev, float *var, float *skew, float *curt);
/* mp2dfr.c */
void mp2dfr(unsigned char a[], unsigned char s[], int n, int *m);
/* mpdiv.c */
void mpdiv(unsigned char q[], unsigned char r[], unsigned char u[], unsigned char v[], int n, int m);
/* mpinv.c */
void mpinv(unsigned char u[], unsigned char v[], int n, int m);
/* mpmul.c */
void mpmul(unsigned char w[], unsigned char u[], unsigned char v[], int n, int m);
/* mpops.c */
void mpadd(unsigned char w[], unsigned char u[], unsigned char v[], int n);
void mpsub(int *is, unsigned char w[], unsigned char u[], unsigned char v[], int n);
void mpsad(unsigned char w[], unsigned char u[], int n, int iv);
void mpsmu(unsigned char w[], unsigned char u[], int n, int iv);
void mpsdv(unsigned char w[], unsigned char u[], int n, int iv, int *ir);
void mpneg(unsigned char u[], int n);
void mpmov(unsigned char u[], unsigned char v[], int n);
void mplsh(unsigned char u[], int n);
/* mppi.c */
void mppi(int n);
/* mprove.c */
void mprove(float **a, float **alud, int n, int indx[], float b[], float x[]);
/* mpsqrt.c */
void mpsqrt(unsigned char w[], unsigned char u[], unsigned char v[], int n, int m);
/* mrqcof.c */
void mrqcof(float x[], float y[], float sig[], int ndata, float a[], int ia[], int ma, float **alpha, float beta[], float *chisq, void (*funcs)(float, float [], float *, float [], int));
/* mrqmin.c */
void mrqmin(float x[], float y[], float sig[], int ndata, float a[], int ia[], int ma, float **covar, float **alpha, float *chisq, void (*funcs)(float, float [], float *, float [], int), float *alamda);
/* newt.c */
void newt(float x[], int n, int *check, void (*vecfunc)(int, float [], float []));
/* odeint.c */
void odeint(float ystart[], int nvar, float x1, float x2, float eps, float h1, float hmin, int *nok, int *nbad, void (*derivs)(float, float [], float []), void (*rkqs)(float [], float [], int, float *, float, float, float [], float *, float *, void (*)(float, float [], float [])));
/* orthog.c */
void orthog(int n, float anu[], float alpha[], float beta[], float a[], float b[]);
/* pade.c */
void pade(double cof[], int n, float *resid);
/* pccheb.c */
void pccheb(float d[], float c[], int n);
/* pcshft.c */
void pcshft(float a, float b, float d[], int n);
/* pearsn.c */
void pearsn(float x[], float y[], unsigned long n, float *r, float *prob, float *z);
/* period.c */
void period(float x[], float y[], int n, float ofac, float hifac, float px[], float py[], int np, int *nout, int *jmax, float *prob);
/* piksr2.c */
void piksr2(int n, float arr[], float brr[]);
/* piksrt.c */
void piksrt(int n, float arr[]);
/* pinvs.c */
void pinvs(int ie1, int ie2, int je1, int jsf, int jc1, int k, float ***c, float **s);
/* plgndr.c */
float plgndr(int l, int m, float x);
/* poidev.c */
float poidev(float xm, long *idum);
/* polcoe.c */
void polcoe(float x[], float y[], int n, float cof[]);
/* polcof.c */
void polcof(float xa[], float ya[], int n, float cof[]);
/* poldiv.c */
void poldiv(float u[], int n, float v[], int nv, float q[], float r[]);
/* polin2.c */
void polin2(float x1a[], float x2a[], float **ya, int m, int n, float x1, float x2, float *y, float *dy);
/* polint.c */
void polint(float xa[], float ya[], int n, float x, float *y, float *dy);
/* powell.c */
void powell(float p[], float **xi, int n, float ftol, int *iter, float *fret, float (*func)(float []));
/* predic.c */
void predic(float data[], int ndata, float d[], int m, float future[], int nfut);
/* probks.c */
float probks(float alam);
/* psdes.c */
void psdes(unsigned long *lword, unsigned long *irword);
/* pwt.c */
void pwt(float a[], unsigned long n, int isign);
/* pwtset.c */
void pwtset(int n);
/* pythag.c */
float pythag(float a, float b);
/* pzextr.c */
void pzextr(int iest, float xest, float yest[], float yz[], float dy[], int nv);
/* qgaus.c */
float qgaus(float (*func)(float), float a, float b);
/* qrdcmp.c */
void qrdcmp(float **a, int n, float *c, float *d, int *sing);
/* qromb.c */
float qromb(float (*func)(float), float a, float b);
/* qromo.c */
float qromo(float (*func)(float), float a, float b, float (*choose)(float (*)(float), float, float, int));
/* qroot.c */
void qroot(float p[], int n, float *b, float *c, float eps);
/* qrsolv.c */
void qrsolv(float **a, int n, float c[], float d[], float b[]);
/* qrupdt.c */
void qrupdt(float **r, float **qt, int n, float u[], float v[]);
/* qsimp.c */
float qsimp(float (*func)(float), float a, float b);
/* qtrap.c */
float qtrap(float (*func)(float), float a, float b);
/* quad3d.c */
float quad3d(float (*func)(float, float, float), float x1, float x2);
float f1(float x);
float f2(float y);
float f3(float z);
/* quadct.c */
void quadct(float x, float y, float xx[], float yy[], unsigned long nn, float *fa, float *fb, float *fc, float *fd);
/* quadmx.c */
void quadmx(float **a, int n);
/* quadvl.c */
void quadvl(float x, float y, float *fa, float *fb, float *fc, float *fd);
/* ran0.c */
float ran0(long *idum);
/* ran1.c */
float ran1(long *idum);
/* ran2.c */
float ran2(long *idum);
/* ran3.c */
float ran3(long *idum);
/* ran4.c */
float ran4(long *idum);
/* rank.c */
void rank(unsigned long n, unsigned long indx[], unsigned long irank[]);
/* ranpt.c */
void ranpt(float pt[], float regn[], int n);
/* ratint.c */
void ratint(float xa[], float ya[], int n, float x, float *y, float *dy);
/* ratlsq.c */
void ratlsq(double (*fn)(double), double a, double b, int mm, int kk, double cof[], double *dev);
/* ratval.c */
double ratval(double x, double cof[], int mm, int kk);
/* rc.c */
float rc(float x, float y);
/* rd.c */
float rd(float x, float y, float z);
/* realft.c */
void realft(float data[], unsigned long n, int isign);
/* rebin.c */
void rebin(float rc, int nd, float r[], float xin[], float xi[]);
/* red.c */
void red(int iz1, int iz2, int jz1, int jz2, int jm1, int jm2, int jmf, int ic1, int jc1, int jcf, int kc, float ***c, float **s);
/* relax.c */
void relax(double **u, double **rhs, int n);
/* relax2.c */
void relax2(double **u, double **rhs, int n);
/* resid.c */
void resid(double **res, double **u, double **rhs, int n);
/* revcst.c */
float revcst(float x[], float y[], int iorder[], int ncity, int n[]);
/* reverse.c */
void reverse(int iorder[], int ncity, int n[]);
/* rf.c */
float rf(float x, float y, float z);
/* rj.c */
float rj(float x, float y, float z, float p);
/* rk4.c */
void rk4(float y[], float dydx[], int n, float x, float h, float yout[], void (*derivs)(float, float [], float []));
/* rkck.c */
void rkck(float y[], float dydx[], int n, float x, float h, float yout[], float yerr[], void (*derivs)(float, float [], float []));
/* rkdumb.c */
void rkdumb(float vstart[], int nvar, float x1, float x2, int nstep, void (*derivs)(float, float [], float []));
/* rkqs.c */
void rkqs(float y[], float dydx[], int n, float *x, float htry, float eps, float yscal[], float *hdid, float *hnext, void (*derivs)(float, float [], float []));
/* rlft3.c */
void rlft3(float ***data, float **speq, unsigned long nn1, unsigned long nn2, unsigned long nn3, int isign);
/* rlftfrag.c */
int main(void);
int main(void);
int main(void);
/* rofunc.c */
float rofunc(float b);
/* rotate.c */
void rotate(float **r, float **qt, int n, int i, float a, float b);
/* rsolv.c */
void rsolv(float **a, int n, float d[], float b[]);
/* rstrct.c */
void rstrct(double **uc, double **uf, int nc);
/* rtbis.c */
float rtbis(float (*func)(float), float x1, float x2, float xacc);
/* rtflsp.c */
float rtflsp(float (*func)(float), float x1, float x2, float xacc);
/* rtnewt.c */
float rtnewt(void (*funcd)(float, float *, float *), float x1, float x2, float xacc);
/* rtsafe.c */
float rtsafe(void (*funcd)(float, float *, float *), float x1, float x2, float xacc);
/* rtsec.c */
float rtsec(float (*func)(float), float x1, float x2, float xacc);
/* rzextr.c */
void rzextr(int iest, float xest, float yest[], float yz[], float dy[], int nv);
/* savgol.c */
void savgol(float c[], int np, int nl, int nr, int ld, int m);
/* scrsho.c */
void scrsho(float (*fx)(float));
/* select.c */
float nselect(unsigned long k, unsigned long n, float arr[]);
/* selip.c */
float selip(unsigned long k, unsigned long n, float arr[]);
/* shell.c */
void shell(unsigned long n, float a[]);
/* shoot.c */
void shoot(int n, float v[], float f[]);
/* shootf.c */
void shootf(int n, float v[], float f[]);
/* simp1.c */
void simp1(float **a, int mm, int ll[], int nll, int iabf, int *kp, float *bmax);
/* simp2.c */
void simp2(float **a, int n, int l2[], int nl2, int *ip, int kp, float *q1);
/* simp3.c */
void simp3(float **a, int i1, int k1, int ip, int kp);
/* simplx.c */
void simplx(float **a, int m, int n, int m1, int m2, int m3, int *icase, int izrov[], int iposv[]);
/* simpr.c */
void simpr(float y[], float dydx[], float dfdx[], float **dfdy, int n, float xs, float htot, int nstep, float yout[], void (*derivs)(float, float [], float []));
/* sinft.c */
void sinft(float y[], int n);
/* slvsm2.c */
void slvsm2(double **u, double **rhs);
/* slvsml.c */
void slvsml(double **u, double **rhs);
/* sncndn.c */
void sncndn(float uu, float emmc, float *sn, float *cn, float *dn);
/* snrm.c */
double snrm(unsigned long n, double sx[], int itol);
/* sobseq.c */
void sobseq(int *n, float x[]);
/* solvde.c */
void solvde(int itmax, float conv, float slowc, float scalv[], int indexv[], int ne, int nb, int m, float **y, float ***c, float **s);
/* sor.c */
void sor(double **a, double **b, double **c, double **d, double **e, double **f, double **u, int jmax, double rjac);
/* sort.c */
void sort(unsigned long n, float arr[]);
/* sort2.c */
void sort2(unsigned long n, float arr[], float brr[]);
/* sort3.c */
void sort3(unsigned long n, float ra[], float rb[], float rc[]);
/* spctrm.c */
void spctrm(FILE *fp, float p[], int m, int k, int ovrlap);
/* spear.c */
void spear(float data1[], float data2[], unsigned long n, float *d, float *zd, float *probd, float *rs, float *probrs);
/* sphbes.c */
void sphbes(int n, float x, float *sj, float *sy, float *sjp, float *syp);
/* splie2.c */
void splie2(float x1a[], float x2a[], float **ya, int m, int n, float **y2a);
/* splin2.c */
void splin2(float x1a[], float x2a[], float **ya, float **y2a, int m, int n, float x1, float x2, float *y);
/* spline.c */
void spline(float x[], float y[], int n, float yp1, float ypn, float y2[]);
/* splint.c */
void splint(float xa[], float ya[], float y2a[], int n, float x, float *y);
/* spread.c */
void spread(float y, float yy[], unsigned long n, float x, int m);
/* sprsax.c */
void sprsax(float sa[], unsigned long ija[], float x[], float b[], unsigned long n);
/* sprsin.c */
void sprsin(float **a, int n, float thresh, unsigned long nmax, float sa[], unsigned long ija[]);
/* sprspm.c */
void sprspm(float sa[], unsigned long ija[], float sb[], unsigned long ijb[], float sc[], unsigned long ijc[]);
/* sprstm.c */
void sprstm(float sa[], unsigned long ija[], float sb[], unsigned long ijb[], float thresh, unsigned long nmax, float sc[], unsigned long ijc[]);
/* sprstp.c */
void sprstp(float sa[], unsigned long ija[], float sb[], unsigned long ijb[]);
/* sprstx.c */
void sprstx(float sa[], unsigned long ija[], float x[], float b[], unsigned long n);
/* stifbs.c */
void stifbs(float y[], float dydx[], int nv, float *xx, float htry, float eps, float yscal[], float *hdid, float *hnext, void (*derivs)(float, float [], float []));
/* stiff.c */
void stiff(float y[], float dydx[], int n, float *x, float htry, float eps, float yscal[], float *hdid, float *hnext, void (*derivs)(float, float [], float []));
/* stoerm.c */
void stoerm(float y[], float d2y[], int nv, float xs, float htot, int nstep, float yout[], void (*derivs)(float, float [], float []));
/* svbksb.c */
void svbksb(float **u, float w[], float **v, int m, int n, float b[], float x[]);
/* svdcmp.c */
void svdcmp(float **a, int m, int n, float w[], float **v);
/* svdfit.c */
void svdfit(float x[], float y[], float sig[], int ndata, float a[], int ma, float **u, float **v, float w[], float *chisq, void (*funcs)(float, float [], int));
/* svdvar.c */
void svdvar(float **v, int ma, float w[], float **cvm);
/* toeplz.c */
void toeplz(float r[], float x[], float y[], int n);
/* tptest.c */
void tptest(float data1[], float data2[], unsigned long n, float *t, float *prob);
/* tqli.c */
void tqli(float d[], float e[], int n, float **z);
/* trapzd.c */
float trapzd(float (*func)(float), float a, float b, int n);
/* tred2.c */
void tred2(float **a, int n, float d[], float e[]);
/* tridag.c */
void tridag(float a[], float b[], float c[], float r[], float u[], unsigned long n);
/* trncst.c */
float trncst(float x[], float y[], int iorder[], int ncity, int n[]);
/* trnspt.c */
void trnspt(int iorder[], int ncity, int n[]);
/* ttest.c */
void ttest(float data1[], unsigned long n1, float data2[], unsigned long n2, float *t, float *prob);
/* tutest.c */
void tutest(float data1[], unsigned long n1, float data2[], unsigned long n2, float *t, float *prob);
/* twofft.c */
void twofft(float data1[], float data2[], float fft1[], float fft2[], unsigned long n);
/* vander.c */
void vander(double x[], double w[], double q[], int n);
/* vegas.c */
void vegas(float regn[], int ndim, float (*fxn)(float [], float), int init, unsigned long ncall, int itmx, int nprn, float *tgral, float *sd, float *chi2a);
/* voltra.c */
void voltra(int n, int m, float t0, float h, float *t, float **f, float (*g)(int, float), float (*ak)(int, int, float, float));
/* wt1.c */
void wt1(float a[], unsigned long n, int isign, void (*wtstep)(float [], unsigned long, int));
/* wtn.c */
void wtn(float a[], unsigned long nn[], int ndim, int isign, void (*wtstep)(float [], unsigned long, int));
/* wwghts.c */
void wwghts(float wghts[], int n, float h, void (*kermom)(double [], double, int));
/* zbrac.c */
int zbrac(float (*func)(float), float *x1, float *x2);
/* zbrak.c */
void zbrak(float (*fx)(float), float x1, float x2, int n, float xb1[], float xb2[], int *nb);
/* zbrent.c */
float zbrent(float (*func)(float), float x1, float x2, float tol);
/* zrhqr.c */
void zrhqr(float a[], int m, float rtr[], float rti[]);
/* zriddr.c */
float zriddr(float (*func)(float), float x1, float x2, float xacc);
/* zroots.c */
void zroots(fcomplex a[], int m, fcomplex roots[], int polish);
