/*\
 *  %
 *  %  Copyright (c) W. Kirk Snyder
 *  %  All Rights Reserved
 *  %
 *  %  This is unpublished source code for SETL2.  There should be no
 *  %  copies which are not in the possession of the author.  If you
 *  %  somehow come across a copy, please return or destroy it.
 *  %
 *
 *  \packagespec{Giveup}
\*/

#ifndef GIVEUP_LOADED

/* public function declarations */

#if UNIX_VARARGS
void giveup();                         /* abort function                    */
#else
void giveup(SETL_SYSTEM_PROTO char *, ...); 
                                       /* abort function                    */
#endif
void user_interrupt(int);              /* ^C trap                           */
#if UNIX | VMS
#ifdef DEBUG
int c_segment_error(void);               /* segmentation error trap           */
int i_segment_error(void);               /* segmentation error trap           */
#endif
#endif
#ifdef TRAPS
#if UNIX_VARARGS
void trap();                           /* program trap                      */
#else
void trap(char *, int, char *, ...);   /* program trap                      */
#endif
#endif

#define GIVEUP_LOADED 1

#endif
